package com.starcharge.wios.Import.impl;

import com.starcharge.wios.Import.Import;
import com.starcharge.wios.dao.entity.Tauxiliarymaterials;
import com.starcharge.wios.dao.mappers.OrderMapper;
import com.starcharge.wios.dao.mappers.TauxiliarymaterialsMapper;
import com.starcharge.wios.enums2.TauxiliarymaterialStatusEnum;
import com.starcharge.wios.vo.DeliveryAddVo;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.validation.ConstraintViolation;
import javax.validation.Validator;
import java.util.List;
import java.util.Set;

/**
 * @projectName:xr-wios
 * @packageName:com.starcharge.wios.Import.impl
 * @Description:TODO
 * @Author:luyincheng
 * @CreateDate: 2023/10/1317:01
 */
@Service
public class AuxiliaryMaterialDeliveryImport implements Import {

    public interface AuxiliaryBatchCreateEntityGroup {
    }

    @Autowired
    private Validator validator;
    @Autowired
    private OrderMapper orderMapper;
    @Autowired
    private TauxiliarymaterialsMapper tauxiliarymaterialsMapper;

    @Override
    public List<?> handle(List<Object> list) {

        for (int i = 1; i < list.size(); i++) {
            StringBuilder error = new StringBuilder();
            List<String> rowdata = (List<String>) list.get(i);
            DeliveryAddVo deliveryAddVo = new DeliveryAddVo();
            deliveryAddVo.setInstallOrder(rowdata.get(0));
            deliveryAddVo.setLogisticOrder(rowdata.get(1));
            try {
                deliveryAddVo.setQuantity(Integer.parseInt(rowdata.get(2)));
            } catch (Exception e) {
                error.append("error:发货数量必填且为整数");
            }

            Set<ConstraintViolation<DeliveryAddVo>> sets = validator.validate(deliveryAddVo, AuxiliaryMaterialDeliveryImport.AuxiliaryBatchCreateEntityGroup.class);
            if (!sets.isEmpty()) {
                error.append(sets.stream().map(ConstraintViolation::getMessage).reduce("error:", (s1, s2) -> s1 + ";" + s2));
            }
            Tauxiliarymaterials tauxiliarymaterialsquery = new Tauxiliarymaterials();
            tauxiliarymaterialsquery.setApplyOrder(deliveryAddVo.getInstallOrder());
            tauxiliarymaterialsquery.setApplyStatus(TauxiliarymaterialStatusEnum.已通过.name());
            List<Tauxiliarymaterials> tauxiliarymaterials = this.tauxiliarymaterialsMapper.selectTAuxiliaryMaterialsList(tauxiliarymaterialsquery);
            if (CollectionUtils.isEmpty(tauxiliarymaterials)) {
                error.append("error:找不到已审批通过辅材申请单");
            } else {
                Tauxiliarymaterials tauxiliarymaterial = tauxiliarymaterials.stream().filter(t -> TauxiliarymaterialStatusEnum.未发货.name().equals(t.getLogisticStatus())).findFirst().orElse(null);
                if (tauxiliarymaterial == null) {
                    error.append("error:找不到已审批且未发货的辅材申请单");
                } else {
                    if (!StringUtils.hasLength(tauxiliarymaterial.getApprovedQuantity())) {
                        tauxiliarymaterial.setApprovedQuantity("0");
                    }
                    if (deliveryAddVo.getQuantity() > Integer.parseInt(tauxiliarymaterial.getApprovedQuantity())) {
                        error.append("error:发货数量大于已审批数量");
                    }
                }
            }
            rowdata.add(error.toString());
        }
        return list;
    }
}
