package com.starcharge.wios.Import.impl;

import com.starcharge.wios.Import.Import;
import com.starcharge.wios.dao.entity.Tauxiliarymaterials;
import com.starcharge.wios.dao.mappers.TauxiliarymaterialsMapper;
import com.starcharge.wios.enums2.TauxiliarymaterialStatusEnum;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.List;
import java.util.Objects;

/**
 * @projectName:wios
 * @packageName:com.starcharge.wios.Import.impl
 * @Description:TODO
 * @Author:luyincheng
 * @CreateDate: 2023/11/1610:13
 */
@Service
public class AuxiliarymaterialsCheckImport implements Import {
    @Autowired
    private TauxiliarymaterialsMapper tauxiliarymaterialsMapper;

    @Override
    public List<?> handle(List<Object> list) {
        for (int i = 1; i < list.size(); i++) {
            List<String> rowdata = (List<String>) list.get(i);
            StringBuilder error = new StringBuilder();
            if (rowdata.size() < 2 || StringUtils.isEmpty(rowdata.get(1))) {
                error.append("error:批准数量不能为空");
            }
            try {
                Float.parseFloat(rowdata.get(1));
            } catch (Exception e) {
                error.append("error:批准数量必须是数字");
                rowdata.add(5, error.toString());
            }
            String s = rowdata.get(1);
            rowdata.remove(1);
            if (StringUtils.isEmpty(rowdata.get(0))) {
                error.append("error:申请单号不能为空");
                rowdata.add(5, error.toString());
            }
            String materialCode = null;
            String materialName = null;
            String applyQuantity = null;
            Tauxiliarymaterials exist = this.tauxiliarymaterialsMapper.selectByApplyOrder(rowdata.get(0));
            if (Objects.isNull(exist)) {
                error.append("error:找不到辅材申请单");
            } else {
                materialCode = exist.getMaterialCode();
                materialName = exist.getMaterialName();
                applyQuantity = exist.getApplyQuantity();
                TauxiliarymaterialStatusEnum enumByName = TauxiliarymaterialStatusEnum.getEnumByName(0, exist.getApplyStatus());
                if (Objects.nonNull(enumByName) && enumByName.getValue() != 1) {
                    error.append("error:辅材申请单:").append(exist.getApplyOrder()).append(" 状态必须是已申请");
                }
                if (Integer.parseInt(s) > Integer.parseInt(exist.getApplyQuantity())) {
                    error.append("error:批准数量不能大于申请数量");
                }
            }
            rowdata.add(materialCode);
            rowdata.add(materialName);
            rowdata.add(applyQuantity);
            rowdata.add(s);
            rowdata.add(error.toString());
        }
        return list;
    }
}
